#include "inkey.ch"
#include "common.ch"
#define CRLF (chr(13)+chr(10))

procedure Main()

   cls

   // Windows Schlieenbutton aktivieren | Close with X-Button

   SetAppWindow():close := {|u1,u2,oXbp| CloseApp() }    // don't use :destroy() here !
   SetAppWindow():configure()

   if RestoreFont()               // registry or INI-File
      @ 24,10 say "Font wurde geladen | font restored !"
   endif

   do while lastkey() # K_ESC  // ESC beendet das Programm

      @1,1 say  "Dies ist ein Test fr XbpCrt - Fonts     "+Version()+" ("+;
                Version(1)+"."+Version(2)+"."+Version(3)+")"
      @3,1 say  "1234567890 ABCDEFGHIJKLMNOPQRSTUVWXYZ  "
      @4,1 say  "1234567890 abcdefghijklmnopqrstuvwxyz  "
      @6,1 say  "wichtig ist ein FixedFont !   | only fixed fonts !"
      @7,1 say  "F2  - startet die Fontauswahl | starts Fontdialog"
      @8,1 say  "F3  - Font merken             | save font for next startup"
      @9,1 say  "F4  - Alaska Crt (16|8)       | back to standard font"
      @10,1 say "F5  - Lsche INI Datei        | delete INI file"

      @12,1 say "ESC - beendet das Programm    | end"

      @20,1 say "SetAppWindow():FontName:  '"+SetAppWindow():FontName+"'"
      if chr(0) $ SetAppWindow():FontName
         @20,73 say " HEX0 " color "w+/r"
      endif
      @21,1 say "TrimHex0(...):            '"+TrimHex0(SetAppWindow():FontName)+"'"
      if chr(0) $ TrimHex0(SetAppWindow():FontName)
         @21,73 say " HEX0 " color "w+/r"
      else
         @21,73 say " OK ! " color "w+/g"
      endif
      @22,1 say "SetAppWindow():FontHeight: "+ntrim(SetAppWindow():FontHeight)
      @23,1 say "SetAppWindow():FontWidth:  "+ntrim(SetAppWindow():FontWidth)

      inkey(0)

      cls

      do case
         case lastkey() = K_F2
              if FontWahl()
                 @ 24,10 say "Font wurde gewhlt !    |  font changed "
              endif
         case lastkey() = K_F3
              if SaveFont()               // registry or INI-File
                 @ 24,10 say "Font wurde gespeichert !   | font saved "
              endif
         case lastkey() = K_F4
              CRT_SetFont()
              CRT_center()
              @ 24,10 say "Alaska Crt (16|8) ? "
         case lastkey() = K_F5
              delete file (GetNameINI())
              @ 24,10 say GetNameINI()+" gelscht ?"+;
                          iif(! file(GetNameINI()),"JA","NEIN")
      endcase


   enddo

return
*-----------------------------------------------------------
procedure CloseApp()
   quit
return
*-----------------------------------------------------------
function nTrim(nNum)
return alltrim(str(nNum))
*-----------------------------------------------------------
function TrimHex0(cTxt)      // AsciiZ -> ASCII
   local nPosHex0
   cTxt := alltrim(cTxt)
   nPosHex0 := at(chr(0),cTxt)
   if nPosHex0 > 0
      cTxt := left(cTxt,nPosHex0-1)
   endif
return alltrim(cTxt)
*-----------------------------------------------------------
function FontWahl(cTitle)
   local oCrt := SetAppWindow()
   local oFont
   local oFontDlg
   local lOK := .f.

   default cTitle to oCrt:title+" - Fontwahl"

   oFontDlg            := XbpFontDialog():New()
   oFontDlg:fixedOnly  := .t.           // CRT-Fenster needs FIXEDFONT
   oFontDlg:familyName := oCrt:FontName // Vorgabe ist aktueller Font | show active font
   oFontDlg:strikeOut  := .f.
*   oFontDlg:style      := .f.
   oFontDlg:underScore := .f.
   oFontDlg:title      := cTitle
   oFontDlg:create()                   // Font-Dialog anfordern

   oFont := oFontDlg:display()

   if ! IsNil(oFont)
      CRT_SetFont( { TrimHex0(oFont:familyName),;
                     oFont:height,;
                     oFont:width } )
      oFont:destroy()                  // Font freigeben
      CRT_center()
      lOK := .t.
   endif

   oFontDlg:destroy()               // Font-Dial

return lOK
*-----------------------------------------------------------
function CRT_SetFont(aFont)  // { NAME, Height, Width }
   local oCrt := SetAppWindow()

   DEFAULT aFont TO { "Alaska Crt" , 16, 8 }
   oCrt:FontName   := aFont[1]
   oCrt:FontHeight := aFont[2]
   oCrt:FontWidth  := aFont[3]
   oCrt:configure()

return .t.
*-----------------------------------------------------------
procedure CRT_center()
   local oCrt := SetAppWindow()
   local aSizeDesktop    := AppDesktop():currentSize()
   local nDesktopBreite  := aSizeDesktop[1]
   local nDesktopHoehe   := aSizeDesktop[2]
   local nBreite, nHoehe, nPosX, nPosY

   nBreite := oCrt:currentSize()[1]
   nHoehe  := oCrt:currentSize()[2]
   if nHoehe < nDesktopHoehe
      nPosY := (nDesktopHoehe-nHoehe)  /2
   else
      nPosY := (nDesktopHoehe-nHoehe)
   endif
   if nBreite < nDesktopBreite
      nPosX := (nDesktopBreite-nBreite)/2
   else
      nPosX := 1
   endif
   oCrt:setPos( { nPosX , nPosY } )
return

*-------------------------------------------------------------------------------------------------------
function SaveFont()               // registry or INI-File - here easy
   local oCrt := SetAppWindow()
   MemoWrit(GetNameINI(), TrimHex0(oCrt:FontName)+ CRLF +;
                          ntrim(oCrt:FontHeight)+ CRLF +;
                          ntrim(oCrt:FontWidth) )
return .t.
*-----------------------------------------------------------
function RestoreFont()            // registry or INI-File
   local lOK := .f.
   local cTxt := memoread(GetNameINI())
   local cFontName   := alltrim(memoLine(cTxt,200,1,1,.f.))
   local nFontHeight := val(memoLine(cTxt,200,2,1,.f.))
   local nFontWidth  := val(memoLine(cTxt,200,3,1,.f.))

   if ! ( empty(cFontName) .or. empty(nFontHeight) .or. empty(nFontWidth) )
      CRT_SetFont( { cFontName,nFontHeight,nFontWidth } )
      CRT_center()
      lOK := .t.
   endif
return lOK
*------------------------------------------------------------
function GetNameINI()
   local cName := AppName(.t.)
   local nLen  := len(cName)
   if upper(right(cName,4)) = ".EXE"
      cName := left(cName,nLen-3)+"INI"
   else
      cName := cName+".INI"
   endif
return cName

